Index: kernel/arch/ia32/include/arch/arch.h
===================================================================
--- kernel/arch/ia32/include/arch/arch.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/arch.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,5 @@
 #define KERN_ia32_ARCH_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern void ia32_pre_main(uint32_t, void *);
Index: kernel/arch/ia32/include/arch/boot/memmap.h
===================================================================
--- kernel/arch/ia32/include/arch/boot/memmap.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/boot/memmap.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -63,5 +63,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern e820memmap_t e820table[MEMMAP_E820_MAX_RECORDS];
Index: kernel/arch/ia32/include/arch/cpuid.h
===================================================================
--- kernel/arch/ia32/include/arch/cpuid.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/cpuid.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -43,6 +43,6 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
 #include <arch/cpu.h>
+#include <stdint.h>
 
 typedef struct {
Index: kernel/arch/ia32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/ia32/include/arch/fpu_context.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/fpu_context.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,5 @@
 #define KERN_ia32_FPU_CONTEXT_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 #define FPU_CONTEXT_ALIGN  16
Index: kernel/arch/ia32/include/arch/interrupt.h
===================================================================
--- kernel/arch/ia32/include/arch/interrupt.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/interrupt.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,7 +36,7 @@
 #define KERN_ia32_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/istate.h>
 #include <arch/pm.h>
+#include <stdint.h>
 
 #define IVT_ITEMS  IDT_ITEMS
Index: kernel/arch/ia32/include/arch/mm/asid.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/asid.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/mm/asid.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -43,5 +43,5 @@
 #define KERN_ia32_ASID_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 typedef int32_t asid_t;
Index: kernel/arch/ia32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/frame.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/mm/frame.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -43,6 +43,4 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
-
 extern void frame_low_arch_init(void);
 extern void frame_high_arch_init(void);
Index: kernel/arch/ia32/include/arch/mm/page.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/page.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/mm/page.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -146,5 +146,5 @@
 #include <mm/mm.h>
 #include <arch/interrupt.h>
-#include <typedefs.h>
+#include <stddef.h>
 
 /* Page fault error codes. */
Index: kernel/arch/ia32/include/arch/proc/task.h
===================================================================
--- kernel/arch/ia32/include/arch/proc/task.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/proc/task.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,5 @@
 #define KERN_ia32_TASK_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 
Index: kernel/arch/ia32/include/arch/proc/thread.h
===================================================================
--- kernel/arch/ia32/include/arch/proc/thread.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/proc/thread.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,6 +36,4 @@
 #define KERN_ia32_THREAD_H_
 
-#include <typedefs.h>
-
 typedef struct {
 } thread_arch_t;
Index: kernel/arch/ia32/include/arch/smp/apic.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/apic.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/smp/apic.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -41,6 +41,6 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
 #include <cpu.h>
+#include <stdint.h>
 
 #define FIXED  (0 << 0)
Index: kernel/arch/ia32/include/arch/smp/mps.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/mps.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/smp/mps.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,5 @@
 #define KERN_ia32_MPS_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <config.h>
Index: kernel/arch/ia32/include/arch/smp/smp.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/smp.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/smp/smp.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,6 @@
 #define KERN_ia32_SMP_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 
 /** SMP config opertaions interface. */
Index: kernel/arch/ia32/include/arch/vreg.h
===================================================================
--- kernel/arch/ia32/include/arch/vreg.h	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/include/arch/vreg.h	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -40,5 +40,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern uint32_t *vreg_ptr;
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -38,5 +38,5 @@
 
 #include <arch.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <print.h>
 #include <fpu_context.h>
Index: kernel/arch/ia32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia32/src/ddi/ddi.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/ddi/ddi.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,5 +36,5 @@
 #include <arch/ddi/ddi.h>
 #include <proc/task.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 #include <mm/slab.h>
Index: kernel/arch/ia32/src/debug/stacktrace.c
===================================================================
--- kernel/arch/ia32/src/debug/stacktrace.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/debug/stacktrace.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -34,6 +34,7 @@
 
 #include <stacktrace.h>
+#include <stdbool.h>
+#include <stdint.h>
 #include <syscall/copy.h>
-#include <typedefs.h>
 
 #define FRAME_OFFSET_FP_PREV  0
Index: kernel/arch/ia32/src/drivers/i8254.c
===================================================================
--- kernel/arch/ia32/src/drivers/i8254.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/drivers/i8254.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -37,5 +37,5 @@
  */
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <time/clock.h>
 #include <time/delay.h>
Index: kernel/arch/ia32/src/drivers/i8259.c
===================================================================
--- kernel/arch/ia32/src/drivers/i8259.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/drivers/i8259.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -39,5 +39,5 @@
 #include <arch/drivers/i8259.h>
 #include <cpu.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <arch/asm.h>
 #include <arch.h>
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/ia32.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -37,5 +37,5 @@
 #include <arch.h>
 #include <arch/arch.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <errno.h>
 #include <mem.h>
Index: kernel/arch/ia32/src/proc/task.c
===================================================================
--- kernel/arch/ia32/src/proc/task.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/proc/task.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -34,5 +34,5 @@
 
 #include <proc/task.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 #include <mm/slab.h>
Index: kernel/arch/ia32/src/syscall.c
===================================================================
--- kernel/arch/ia32/src/syscall.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/syscall.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -36,6 +36,6 @@
 #include <arch/cpu.h>
 #include <arch/asm.h>
-#include <typedefs.h>
 #include <arch/pm.h>
+#include <stdint.h>
 
 #ifndef PROCESSOR_i486
Index: kernel/arch/ia32/src/userspace.c
===================================================================
--- kernel/arch/ia32/src/userspace.c	(revision 44a7ee5373ccc121fce74799244a44867eed301d)
+++ kernel/arch/ia32/src/userspace.c	(revision 83dab11c929c1a48613d4dc70ed8ca9113463484)
@@ -35,5 +35,5 @@
 #include <userspace.h>
 #include <arch/pm.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <arch.h>
 #include <abi/proc/uarg.h>